# importy se píší na začátek, aby člověk nemusel prohledávat celý program, jaké další knihovny se používají...
import turtle

#
# A) výpočet předpisu pro pátou generaci Penroseova dláždění
#    https://github.com/rodrigosetti/l-systems/blob/master/examples/penrose.json
#

stará_generace = '[7]++[7]++[7]++[7]++[7]'

pravidla = {
    '6': '8f++9f----7f[-8f----6f]++',
    '7': '+8f--9f[---6f--7f]+',
    '8': '-6f++7f[+++8f++9f]-',
    '9': '--8f++++6f[+9f++++7f]--7f',
    'f': '',
}

for i in range(1, 6):
    nová_generace = ''  # prázdný řetězec
    # výpočet nové generace
    for znak in stará_generace:
        nová_generace += pravidla.get(znak, znak)
    # nová generace se stane starou a z ní vypočítáme ještě novější generaci
    stará_generace = nová_generace

#
# B) vykreslení páté generace Penroseova dláždění
#

#turtle.speed(0)
turtle.tracer(10)
turtle.teleport(-200, 0)
turtle.left(90)

předpis = stará_generace

# zaveďmež si užitečné "konstanty" -- jiný zápis pomocí tzv. n-tic (vlevo od '=' dvojce, vpravo od '=' také dvojce)
# PS: Python pojem 'konstanta' nezná, ale při pojmenování pomocí samých velkých písmen všichni předstírají, že to konstanty jsou...
KROK, ÚHEL = 10, 36

turtle.title('Dračí křivka (3. generace)')
turtle.bgcolor('lightblue')
turtle.pensize(2)

zásobník_stavů_želvy = []   # list()

for znak in předpis:
    match znak:
        case '6' | '7' | '8' | '9':
            turtle.forward(KROK)
        case '-':
            turtle.right(ÚHEL)
        case '+':
            turtle.left(ÚHEL)
        case '[':
            zásobník_stavů_želvy.append(
                (turtle.position(), turtle.heading())   # dvojce (= jeden prvek)
            )
        case ']':
            poslední_stav_želvy = zásobník_stavů_želvy.pop(-1)
            pozice, úhel = poslední_stav_želvy  # dvojce = dvojce
            # při přesunu želva nekreslí
            turtle.penup()
            turtle.setposition(pozice)
            turtle.pendown()
            # při otáčení se nekreslí automaticky -- želva je pořád na stejném místě
            turtle.setheading(úhel)

turtle.mainloop()
